unit thesisU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, math, Isaac;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit6: TEdit;
    Label6: TLabel;
    Edit7: TEdit;
    Label13: TLabel;
    Label7: TLabel;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Button2: TButton;
    Label14: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Edit12: TEdit;
    Edit13: TEdit;
    Label15: TLabel;
    Edit14: TEdit;
    Button3: TButton;
    Label18: TLabel;
    Button4: TButton;
    GroupBox1: TGroupBox;
    Button5: TButton;
    Label19: TLabel;
    Edit15: TEdit;
    Label20: TLabel;
    Edit16: TEdit;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

const pathSteps = 2000;

implementation

{$R *.DFM}

// "Hjemmedefineret sign-funktion, s:
//  P(sign(x) =  1) = 1/2
//  P(sign(x) = -1) = 1/2
function sign(x :longint) :real;
begin
if x<0 then
  result:=1
else
  result:=-1;
end;

{Get next signed 32 bit integer, transform into the interval (0,1)
 and awoid the values 0 and 1 by calling/calculating
 "(x.val+2147483649)/4294967297"
}

procedure TForm1.Button1Click(Sender: TObject);
var reiteration,N,M1,M2,M3,M4,M5,i,j: longint;
    alpha,sigma,gammaAfToMinusAlpha,Calpha,meanWtoAlpha,jumpTimes,stableX,finalValue: double;
    x: TIsaac;
    fileOutM1,fileOutM2,fileOutM3,fileOutM4,fileOutM5,fileOutN:textfile;
    beginDateTime:tdatetime;
begin
  beginDateTime       := time;
  button1.caption     := '(running...)';
  reiteration         := strtoint(edit1.text);
  N                   := strtoint(edit2.text);
  M1                  := strtoint(edit5.text);
  M2                  := strtoint(edit8.text);
  M3                  := strtoint(edit9.text);
  M4                  := strtoint(edit10.text);
  M5                  := strtoint(edit11.text);
  alpha               := strtofloat(edit3.text);
  sigma               := strtofloat(edit4.text);
  gammaAfToMinusAlpha := strtofloat(edit7.text);
  if alpha=1 then
    Calpha := 2/pi
  else
    Calpha := ((1 - alpha) / (gammaAfToMinusAlpha * cos(pi * alpha / 2)));
  meanWtoAlpha := 1 / (alpha + 1);
  x := TIsaac.Create;
  assignfile(fileOutM1,'c:\data_M'+inttostr(M1)+'_alpha'+floattostr(alpha)+'.txt');
  assignfile(fileOutM2,'c:\data_M'+inttostr(M2)+'_alpha'+floattostr(alpha)+'.txt');
  assignfile(fileOutM3,'c:\data_M'+inttostr(M3)+'_alpha'+floattostr(alpha)+'.txt');
  assignfile(fileOutM4,'c:\data_M'+inttostr(M4)+'_alpha'+floattostr(alpha)+'.txt');
  assignfile(fileOutM5,'c:\data_M'+inttostr(M5)+'_alpha'+floattostr(alpha)+'.txt');
  assignfile(fileOutN,'c:\data_N'+inttostr(N)+'_alpha'+floattostr(alpha)+'.txt');
  rewrite(fileoutM1);
  rewrite(fileoutM2);
  rewrite(fileoutM3);
  rewrite(fileoutM4);
  rewrite(fileoutM5);
  rewrite(fileoutN);
  try
    x.Seed([GetMessageTime, GetMessagePos], true);
    for i:=1 to reiteration do
      begin
      jumpTimes := 0;
      stableX   := 0;
      for j:=1 to M1 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutM1,finalValue);
      for j:=M1+1 to M2 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutM2,finalValue);
      for j:=M2+1 to M3 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutM3,finalValue);
      for j:=M3+1 to M4 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutM4,finalValue);
      for j:=M4+1 to M5 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutM5,finalValue);
      for j:=M5+1 to N do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        stableX   := stableX + sign(x.val)
                             * power(jumpTimes, -1 / alpha)
                             * (x.val + 2147483649.0) / 4294967297;
        end;
      finalValue := sigma * power(Calpha/meanWtoAlpha,1/alpha) * stableX;
      writeln(fileOutN,finalValue);
      end;
  finally
    x.Free;
    closefile(fileoutM1);
    closefile(fileoutM2);
    closefile(fileoutM3);
    closefile(fileoutM4);
    closefile(fileoutM5);
    closefile(fileoutN);
  end;
  edit6.text      := inttostr(floor(time)-floor(beginDatetime))
                     + ' days, ' + timetostr(time-beginDatetime);
  button1.caption := 'Done!';
end;

procedure TForm1.Button2Click(Sender: TObject);
var reiteration,N,M1,M2,M3,M4,M5,i,j: longint;
    a,b,jumpTimes,gammaX,finalValue: double;
    x: TIsaac;
    fileOutM1,fileOutM2,fileOutM3,fileOutM4,fileOutM5,fileOutN:textfile;
    beginDateTime:tdatetime;
begin
  beginDateTime       := time;
  button2.caption     := '(running...)';
  reiteration         := strtoint(edit1.text);
  N                   := strtoint(edit2.text);
  M1                  := strtoint(edit5.text);
  M2                  := strtoint(edit8.text);
  M3                  := strtoint(edit9.text);
  M4                  := strtoint(edit10.text);
  M5                  := strtoint(edit11.text);
  a                   := strtofloat(edit12.text);
  b                   := strtofloat(edit13.text);
//  gammaAfToMinusAlpha := strtofloat(edit7.text);
{  if alpha=1 then
    Calpha := 2/pi
  else
    Calpha := ((1 - alpha) / (gammaAfToMinusAlpha * cos(pi * alpha / 2)));
  meanWtoAlpha := 1 / (alpha + 1);}
  x := TIsaac.Create;
  assignfile(fileOutM1,'c:\data_M'+inttostr(M1)+'_a'+floattostr(a)+'.txt');
  assignfile(fileOutM2,'c:\data_M'+inttostr(M2)+'_a'+floattostr(a)+'.txt');
  assignfile(fileOutM3,'c:\data_M'+inttostr(M3)+'_a'+floattostr(a)+'.txt');
  assignfile(fileOutM4,'c:\data_M'+inttostr(M4)+'_a'+floattostr(a)+'.txt');
  assignfile(fileOutM5,'c:\data_M'+inttostr(M5)+'_a'+floattostr(a)+'.txt');
  assignfile(fileOutN,'c:\data_N'+inttostr(N)+'_a'+floattostr(a)+'.txt');
  rewrite(fileoutM1);
  rewrite(fileoutM2);
  rewrite(fileoutM3);
  rewrite(fileoutM4);
  rewrite(fileoutM5);
  rewrite(fileoutN);
  try
    x.Seed([GetMessageTime, GetMessagePos], true);
    for i:=1 to reiteration do
      begin
      jumpTimes := 0;
      gammaX    := 0;
      for j:=1 to M1 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutM1,finalValue);
      for j:=M1+1 to M2 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutM2,finalValue);
      for j:=M2+1 to M3 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutM3,finalValue);
      for j:=M3+1 to M4 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutM4,finalValue);
      for j:=M4+1 to M5 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutM5,finalValue);
      for j:=M5+1 to N do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        gammaX    := gammaX + exp(-1*jumpTimes/a)
                            * (-1*ln((x.val + 2147483649.0) / 4294967297));
        end;
      finalValue := b * gammaX;
      writeln(fileOutN,finalValue);
      end;
  finally
    x.Free;
    closefile(fileoutM1);
    closefile(fileoutM2);
    closefile(fileoutM3);
    closefile(fileoutM4);
    closefile(fileoutM5);
    closefile(fileoutN);
  end;
  edit6.text      := inttostr(floor(time)-floor(beginDatetime))
                     + ' days, ' + timetostr(time-beginDatetime);
  button2.caption := 'Done!';
end;

// Antager b=1 i beregningen af residualerne!!!
procedure TForm1.Button3Click(Sender: TObject);
var N,M1,i,j: longint;
    a,sum1,sum2,sum3,residual: double;
    beginDateTime:tdatetime;
begin
  button3.caption     := '(running...)';
  beginDateTime       := time;
  N                   := strtoint(edit2.text);
  M1                  := strtoint(edit5.text);
  a                   := strtofloat(edit12.text);
//  b                   := strtofloat(edit13.text);
  sum1                := 0;
  sum2                := 0;
  sum3                := 0;
  for j:=M1+2 to N do
    for i:=M1+1 to j-1 do
      sum1 := sum1 + power(1+1/a,-1*j) * power((2+a)/(1+a),-1*i);
  for i:=M1+1 to N do
    sum2 := sum2 + power(1+2/a,-1*i);
  for i:=M1+1 to N do
    sum3 := sum3 + power(1+1/a,-1*i);
  residual := 2 * sum1 + sum2 - power(sum3,2);
  edit14.text:=floattostr(residual);
  edit6.text      := inttostr(floor(time)-floor(beginDatetime))
                     + ' days, ' + timetostr(time-beginDatetime);
  button3.caption     := 'Beregn residual fra M1 til N';
end;

function ElogInt(lower:double):double;
var upper, divisions, sum, width, counter, x, left, right, middle, c: double;
procedure formula;
  begin
  c := exp(-1*power(ln(x),2))/x;
  end;
begin
upper:=250;
divisions:=5000;
sum := 0;
width := (upper - lower) / (2 * divisions);
counter := 1;
repeat
  left := lower + 2 * (counter - 1) * width;
  right := lower + 2 * counter * width;
  middle := (left + right) / 2;
  x := left;
  formula;
  left := c;
  x := middle;
  formula;
  middle := c;
  x := right;
  formula;
  right := c;
  sum := (width * (left + 4 * middle + right)) / 3 + sum;
  counter := counter + 1;
  until counter = divisions;
ElogInt:=sum;
end;

function ElogIntInvers(int:double):double;
var X,beregnetInt,step:double;
    goingUp:boolean;
const precision = 0.0000001;
begin
goingUp:=false;
step:=0.9;
X:=5;
beregnetInt:=ElogInt(X);
repeat
  if beregnetInt < int then
    begin
    if goingUp then
      begin
      step:=step/2;
      goingUp:=false;
      end;
    X:=X-step;
    end
  else
    begin
    if not goingUp then
      begin
      step:=step/2;
      goingUp:=true;
      end;
    X:=X+step;
    end;
  beregnetInt:=ElogInt(X);
  until abs(beregnetInt-int) < precision;
ElogIntInvers:=X;
end;

procedure TForm1.Button4Click(Sender: TObject);
var reiteration,N,M1,M2,M3,M4,M5,i,j: longint;
    jumpTimes,ownX: double;
    x: TIsaac;
    fileOutM1,fileOutM2,fileOutM3,fileOutM4,fileOutM5,fileOutN:textfile;
    beginDateTime:tdatetime;
const Elog11 = 0.88622691266;
begin
  beginDateTime       := time;
  button4.caption     := '(running...)';
  reiteration         := strtoint(edit1.text);
  N                   := strtoint(edit2.text);
  M1                  := strtoint(edit5.text);
  M2                  := strtoint(edit8.text);
  M3                  := strtoint(edit9.text);
  M4                  := strtoint(edit10.text);
  M5                  := strtoint(edit11.text);
  x := TIsaac.Create;
  assignfile(fileOutM1,'c:\data_M'+inttostr(M1)+'_ownEx.txt');
  assignfile(fileOutM2,'c:\data_M'+inttostr(M2)+'_ownEx.txt');
  assignfile(fileOutM3,'c:\data_M'+inttostr(M3)+'_ownEx.txt');
  assignfile(fileOutM4,'c:\data_M'+inttostr(M4)+'_ownEx.txt');
  assignfile(fileOutM5,'c:\data_M'+inttostr(M5)+'_ownEx.txt');
  assignfile(fileOutN,'c:\data_N'+inttostr(N)+'_ownEx.txt');
  rewrite(fileoutM1);
  rewrite(fileoutM2);
  rewrite(fileoutM3);
  rewrite(fileoutM4);
  rewrite(fileoutM5);
  rewrite(fileoutN);
  try
    x.Seed([GetMessageTime, GetMessagePos], true);
    for i:=1 to reiteration do
      begin
      jumpTimes := 0;
      ownX      := 0;
      for j:=1 to M1 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutM1,ownX);
      for j:=M1+1 to M2 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutM2,ownX);
      for j:=M2+1 to M3 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutM3,ownX);
      for j:=M3+1 to M4 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutM4,ownX);
      for j:=M4+1 to M5 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutM5,ownX);
      for j:=M5+1 to N do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        if jumpTimes < Elog11 then
          ownX := ownX + ElogIntInvers(jumpTimes)
        else
          ownX := ownX + 1/power(((jumpTimes-Elog11)/2+1),2);
        end;
      writeln(fileOutN,ownX);
      end;
  finally
    x.Free;
    closefile(fileoutM1);
    closefile(fileoutM2);
    closefile(fileoutM3);
    closefile(fileoutM4);
    closefile(fileoutM5);
    closefile(fileoutN);
  end;
  edit6.text      := inttostr(floor(time)-floor(beginDatetime))
                     + ' days, ' + timetostr(time-beginDatetime);
  button4.caption := 'Done!';
end;


procedure TForm1.Button5Click(Sender: TObject);
var N,M1,M2,M3,M4,Mfak1,Mfak2,Mfak3,Mfak4,reiteration,k,i,j: longint;
    alpha,sigma,gammaAfToMinusAlpha,Calpha,meanWtoAlpha,jumpTimes,sumTerm,U,norm,normPath,normeringskonst: double;
    supValue,readM,readN: double;
    stableXpath,stableNormXpath : array[0..pathSteps] of double;
    RiemannNstep1,RiemannNstep2,RiemannNstep3,RiemannNstep4: array[0..2000] of double;
    EulerMstep1,EulerMstep2,EulerMstep3,EulerMstep4: array[0..2000] of double;
    x: TIsaac;
    fileOutSup1,fileOutSup2,fileOutSup3,fileOutSup4:textfile;
    fileOutRiemannN,fileOutEulerM1,fileOutEulerM2,fileOutEulerM3,fileOutEulerM4:textfile;
    beginDateTime:tdatetime;
    stepsize,halfStepsize,t,expMinusCT,RiemannSum,Xti:double;
    muSDE,x0SDE,cSDE,sigmaSDE:double;
begin
  beginDateTime       := time;
  button5.caption     := '(running...)';
  reiteration         := strtoint(edit1.text);
  N                   := strtoint(edit2.text);
  Mfak1               := 400;  //40
  Mfak2               := 200;  //16
  Mfak3               := 100;   // 8
  Mfak4               := 50;   // 4
  M1                  := round(pathSteps/Mfak1);
  M2                  := round(pathSteps/Mfak2);
  M3                  := round(pathSteps/Mfak3);
  M4                  := round(pathSteps/Mfak4);
  alpha               := strtofloat(edit3.text);
  sigma               := strtofloat(edit4.text);
  gammaAfToMinusAlpha := strtofloat(edit7.text);
  if alpha=1 then
    Calpha := 2/pi
  else
    Calpha := ((1 - alpha) / (gammaAfToMinusAlpha * cos(pi * alpha / 2)));
  meanWtoAlpha    := 1 / (alpha + 1);
  normeringskonst := sigma * power(Calpha/meanWtoAlpha,1/alpha);
  muSDE           := 4;
  x0SDE           := 4.1;
  cSDE            := 0.5;
  sigmaSDE        := 1;
  stepsize        := 1 / pathSteps;
  halfStepsize    := stepsize / 2;
  x := TIsaac.Create;
  if checkbox1.checked then
    begin
    assignfile(fileOutRiemannN,'c:\path_step'+inttostr(pathSteps)+'_N'+inttostr(N)+'_alpha'+floattostr(alpha)+'.txt');
    assignfile(fileOutEulerM1,'c:\path_step'+inttostr(pathSteps)+'_M'+inttostr(M1)+'_alpha'+floattostr(alpha)+'.txt');
    assignfile(fileOutEulerM2,'c:\path_step'+inttostr(pathSteps)+'_M'+inttostr(M2)+'_alpha'+floattostr(alpha)+'.txt');
    assignfile(fileOutEulerM3,'c:\path_step'+inttostr(pathSteps)+'_M'+inttostr(M3)+'_alpha'+floattostr(alpha)+'.txt');
    assignfile(fileOutEulerM4,'c:\path_step'+inttostr(pathSteps)+'_M'+inttostr(M4)+'_alpha'+floattostr(alpha)+'.txt');
    rewrite(fileOutRiemannN);
    rewrite(fileOutEulerM1);
    rewrite(fileOutEulerM2);
    rewrite(fileOutEulerM3);
    rewrite(fileOutEulerM4);
    end;
  assignfile(fileOutSup1,'c:\path_step'+inttostr(round(pathSteps/10))+'_alpha'+floattostr(alpha)+'_sup.txt');
  assignfile(fileOutSup2,'c:\path_step'+inttostr(round(pathSteps/4))+'_alpha'+floattostr(alpha)+'_sup.txt');
  assignfile(fileOutSup3,'c:\path_step'+inttostr(round(pathSteps/2))+'_alpha'+floattostr(alpha)+'_sup.txt');
  assignfile(fileOutSup4,'c:\path_step'+inttostr(pathSteps)+'_alpha'+floattostr(alpha)+'_sup.txt');
  rewrite(fileOutSup1);
  rewrite(fileOutSup2);
  rewrite(fileOutSup3);
  rewrite(fileOutSup4);
  try
    x.Seed([GetMessageTime, GetMessagePos], true);
    for k:=1 to reiteration do
      begin
      jumpTimes := 0;
      for j:=0 to pathSteps do
        stableXpath[j] := 0;
      for i:=1 to M4 do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        sumTerm   := sign(x.val) * power(jumpTimes, -1 / alpha);
                                 //* (x.val + 2147483649.0) / 4294967297;
        U         := (x.val + 2147483649.0) / 4294967297;                // Ligefordelt var
        for j:=pathSteps downto 0 do
          if (j/pathSteps) >= U then
            stableXpath[j] := stableXpath[j] + sumTerm
          else
            break;
        end;
      normPath := 0;
      stableNormXpath[0] := stableXpath[0];
      for j:=1 to round(pathSteps/Mfak4) do  // lgger BM til processen
        begin
        norm     := sqrt(-2 * ln((x.val + 2147483649.0) / 4294967297)) *   //N(0,1) genereres
                    sin(2 * pi * ((x.val + 2147483649.0) / 4294967297));
        normpath := normpath + sqrt(strtofloat(edit16.text)/(Mfak4*pathSteps)) * norm;        //N(0,sigma^2/(4*PathSteps)) genereres
        stableNormXpath[Mfak4*j] := normeringskonst * stableXpath[Mfak4*j] + normpath;
        end;
      EulerMstep1[0] := x0SDE;
      if checkbox1.checked then
        writeln(fileOutEulerM1,x0SDE);
      Xti := x0SDE;
      for j:=1 to round(pathSteps/Mfak1) do  // Euler apprx. med en 40. del stepsize
        begin
        Xti := Xti +
               cSDE * (muSDE - Xti) * Mfak1 * stepsize +
               sigmaSDE * (stableNormXpath[Mfak1*j] - stableNormXpath[Mfak1*(j-1)]);
        EulerMstep1[j] := Xti;
        if checkbox1.checked then
          writeln(fileOutEulerM1,Xti);
        end;
      EulerMstep2[0] := x0SDE;
      if checkbox1.checked then
        writeln(fileOutEulerM2,x0SDE);
      Xti := x0SDE;
      for j:=1 to round(pathSteps/Mfak2) do  // Euler apprx. med en 16. del stepsize
        begin
        Xti := Xti +
               cSDE * (muSDE - Xti) * Mfak2 * stepsize +
               sigmaSDE * (stableNormXpath[Mfak2*j] - stableNormXpath[Mfak2*(j-1)]);
        EulerMstep2[j] := Xti;
        if checkbox1.checked then
          writeln(fileOutEulerM2,Xti);
        end;
      EulerMstep3[0] := x0SDE;
      if checkbox1.checked then
        writeln(fileOutEulerM3,x0SDE);
      Xti := x0SDE;
      for j:=1 to round(pathSteps/Mfak3) do  // Euler apprx. med en 8. del stepsize
        begin
        Xti := Xti +
               cSDE * (muSDE - Xti) * Mfak3 * stepsize +
               sigmaSDE * (stableNormXpath[Mfak3*j] - stableNormXpath[Mfak3*(j-1)]);
        EulerMstep3[j] := Xti;
        if checkbox1.checked then
          writeln(fileOutEulerM3,Xti);
        end;
      EulerMstep4[0] := x0SDE;
      if checkbox1.checked then
        writeln(fileOutEulerM4,x0SDE);
      Xti := x0SDE;
      for j:=1 to round(pathSteps/Mfak4) do  // Euler apprx. med en 4. del stepsize
        begin
        Xti := Xti +
               cSDE * (muSDE - Xti) * Mfak4 * stepsize +
               sigmaSDE * (stableNormXpath[Mfak4*j] - stableNormXpath[Mfak4*(j-1)]);
        EulerMstep4[j] := Xti;
        if checkbox1.checked then
          writeln(fileOutEulerM4,Xti);
        end;
      for i:=M4+1 to N do
        begin
        jumpTimes := jumpTimes - ln((x.val + 2147483649.0) / 4294967297);
        sumTerm   := sign(x.val) * power(jumpTimes, -1 / alpha);
                                 //* (x.val + 2147483649.0) / 4294967297;
        U         := (x.val + 2147483649.0) / 4294967297;                // Ligefordelt var
        for j:=pathSteps downto 0 do
          if (j/pathSteps) >= U then
            stableXpath[j] := stableXpath[j] + sumTerm
          else
            break;
        end;
      for j:=0 to pathSteps do
        stableXpath[j] := normeringskonst * stableXpath[j];
      RiemannNstep1[0] := x0SDE;
      RiemannSum       := 0;
      for j:=1 to round(pathSteps/(Mfak1/4)) do      // Riemann apprx. med en 10. del stepsize
        begin
        t          := (Mfak1/4)*j/pathSteps;
        expMinusCT := exp(-cSDE*t);
        RiemannSum := RiemannSum +
                      exp(cSDE*(t-(Mfak1/4)*halfStepsize)) * (stableXpath[round(Mfak1/4)*j] - stableXpath[round(Mfak1/4)*(j-1)]);
        if j mod 4 = 0 then
          RiemannNstep1[round(j/4)] := x0SDE * expMinusCT +
                                       muSDE * (1 - expMinusCT) +
                                       sigmaSDE * expMinusCT * RiemannSum;
        end;
      RiemannNstep2[0] := x0SDE;
      RiemannSum       := 0;
      for j:=1 to round(pathSteps/(Mfak2/4)) do      // Riemann apprx. med en 4. del stepsize
        begin
        t          := (Mfak2/4)*j/pathSteps;
        expMinusCT := exp(-cSDE*t);
        RiemannSum := RiemannSum +
                      exp(cSDE*(t-(Mfak2/4)*halfStepsize)) * (stableXpath[round(Mfak2/4)*j] - stableXpath[round(Mfak2/4)*(j-1)]);
        if j mod 4 = 0 then
          RiemannNstep2[round(j/4)] := x0SDE * expMinusCT +
                                       muSDE * (1 - expMinusCT) +
                                       sigmaSDE * expMinusCT * RiemannSum;
        end;
      RiemannNstep3[0] := x0SDE;
      RiemannSum       := 0;
      for j:=1 to round(pathSteps/(Mfak3/4)) do      // Riemann apprx. med en 2. del stepsize
        begin
        t          := (Mfak3/4)*j/pathSteps;
        expMinusCT := exp(-cSDE*t);
        RiemannSum := RiemannSum +
                      exp(cSDE*(t-(Mfak3/4)*halfStepsize)) * (stableXpath[round(Mfak3/4)*j] - stableXpath[round(Mfak3/4)*(j-1)]);
        if j mod 4 = 0 then
          RiemannNstep3[round(j/4)] := x0SDE * expMinusCT +
                                       muSDE * (1 - expMinusCT) +
                                       sigmaSDE * expMinusCT * RiemannSum;
        end;
      RiemannNstep4[0] := x0SDE;
      if checkbox1.checked then
        writeln(fileOutRiemannN,x0SDE);
      RiemannSum := 0;
      for j:=1 to pathSteps do      // Riemann apprx. med stepsize som angivet (kun hver fjerde vrdi udskrives)
        begin
        t          := j/pathSteps;
        expMinusCT := exp(-cSDE*t);
        RiemannSum := RiemannSum +
                      exp(cSDE*(t-halfStepsize)) * (stableXpath[j] - stableXpath[j-1]);
        if j mod 4 = 0 then
          begin
          RiemannNstep4[round(j/4)] := x0SDE * expMinusCT +
                                       muSDE * (1 - expMinusCT) +
                                       sigmaSDE * expMinusCT * RiemannSum;
          if checkbox1.checked then
            writeln(fileOutRiemannN,RiemannNstep4[round(j/4)]);
          end;
        end;
      supValue := 0;
      for j:=0 to round(pathSteps/Mfak1) do
        if abs(EulerMstep1[j]-RiemannNstep1[j]) > supValue then
          supValue := abs(EulerMstep1[j]-RiemannNstep1[j]);
      writeln(fileOutSup1,power(supValue,0.25));
      supValue := 0;
      for j:=0 to round(pathSteps/Mfak2) do
        if abs(EulerMstep2[j]-RiemannNstep2[j]) > supValue then
          supValue := abs(EulerMstep2[j]-RiemannNstep2[j]);
      writeln(fileOutSup2,power(supValue,0.25));
      supValue := 0;
      for j:=0 to round(pathSteps/Mfak3) do
        if abs(EulerMstep3[j]-RiemannNstep3[j]) > supValue then
          supValue := abs(EulerMstep3[j]-RiemannNstep3[j]);
      writeln(fileOutSup3,power(supValue,0.25));
      supValue := 0;
      for j:=0 to round(pathSteps/Mfak4) do
        if abs(EulerMstep4[j]-RiemannNstep4[j]) > supValue then
          supValue := abs(EulerMstep4[j]-RiemannNstep4[j]);
      writeln(fileOutSup4,power(supValue,0.25));
      end;
  finally
    x.Free;
    if checkbox1.checked then
      begin
      closefile(fileoutEulerM1);
      closefile(fileoutEulerM2);
      closefile(fileoutEulerM3);
      closefile(fileoutEulerM4);
      closefile(fileoutRiemannN);
      end;
    closefile(fileOutSup1);
    closefile(fileOutSup2);
    closefile(fileOutSup3);
    closefile(fileOutSup4);
  end;
  edit6.text      := inttostr(floor(time)-floor(beginDatetime))
                     + ' days, ' + timetostr(time-beginDatetime);
  button5.caption := 'Done!';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
edit15.Text := inttostr(pathSteps);
end;

end.
